/* Project SWORD
   V2.0

   SubSystem  : Little usefull graphical objects
   File       : Include/Gadgets/Scroller.H
   Author     : Eric NICOLAS
   Overview   : TScroller object
   UpDate     : Nov 12, 1995

** Copyright (C) 1993,1995 Eric NICOLAS
**
** This file is distributed under the terms listed in the document
** "copying.en". A copy of "copying.en" should accompany this file.
** if not, a copy should be available from where this file was obtained.
** This file may not be distributed without a verbatim copy of "copying.en".
**
** This file is distributed WITHOUT ANY WARRANTY; without even the implied
** warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

#ifndef _GADGETS_SCROLLER_H_
#define _GADGETS_SCROLLER_H_

// --- TScroller object

extern short RegTScroller;
extern char *IdentTScroller;

struct TScroller : TZone
{ protected:
    TLift *Horiz, *Vert;
    int    WideL,  WideH;
    int    DecX,   DecY;
    int    StepX,  StepY;
  public:
  // Constructors
			 TScroller();
			 TScroller(int X, int Y, int L, int H, int WL, int WH, TLift *_Horiz, TLift *_Vert);
          TScroller(TRect& R, int WL, int WH, TLift *_Horiz, TLift *_Vert);
			 void     Init(int WL, int WH, TLift *_Horiz, TLift *_Vert);
  // Gestion des ascenseurs
  virtual boolean  HandleCommand(long Command, char Info08b=0, short Info16b=0, long Info32b=0, void *InfoPtr=NULL);
          void     SynchroLifts(void);
  virtual void     DoChangeSize(int dX, int dY);
  virtual void     Draw(TRect& Clip);
  // Objects streams
  virtual TAtom*   Duplicate(void);
};

// Inline functions

inline TAtom* TScroller::Duplicate(void)
{ return new TScroller();
}

#endif // _GADGETS_SCROLLER_H_