/* Project SWORD
   V2.0

   SubSystem : Samples programs : MINI_APP (mini application)
   File      : Samples/Mini_App/Mini_App.CC
   Author    : Eric NICOLAS
   Overview  : MINI_APP sample program main file
   UpDate    : Nov 20, 1995

** Copyright (C) 1993,1995 Eric NICOLAS
**
** This file is distributed under the terms listed in the document
** "copying.en". A copy of "copying.en" should accompany this file.
** if not, a copy should be available from where this file was obtained.
** This file may not be distributed without a verbatim copy of "copying.en".
**
** This file is distributed WITHOUT ANY WARRANTY; without even the implied
** warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

#include "Sword.H"

// ==== APPLICATION OBJECT ===================================================

// This object is the application object. Construct the main menu.

struct THelloApp : TApp
{ THelloApp(char *argv0);
  virtual boolean HandleCommand(long Command, char Info08b=0, short Info16b=0, long Info32b=0, void *InfoPtr=NULL);
};

THelloApp::THelloApp(char *argv0) : TApp(argv0)
{ // Create main menu
  TMenu *Menu=new TMenu("MiniApp",opMainMenu);
    Menu->Insert(new TMenuChoice("&Quit",ScanAltX,cmQuit));
    Menu->InitChoices();
  Desktop->Insert(Menu);
}

boolean THelloApp::HandleCommand(long Command, char Info08b, short Info16b, long Info32b, void *InfoPtr)
{ if (TApp::HandleCommand(Command,Info08b,Info16b,Info32b,InfoPtr)) return TRUE;
  switch(Command)
  { case cmQuit:
      ExitCode=1;
      return TRUE;
  }
  return FALSE;
}

// ==== MAIN PROGRAMM ========================================================

int main(char , char *argv[])
{ THelloApp *HelloApp;

  // Execute Application
  HelloApp=new THelloApp(argv[0]);
  HelloApp->Run();
  delete HelloApp;

  return 0;
}
